import { ActionFormData, ModalFormData } from "@minecraft/server-ui";
import { ChestFormData } from './extensions/forms.js';
import { ItemStack, Player, system, world, Container } from "@minecraft/server";
import { Vector3 } from "./VectorMath/index.js";

world.beforeEvents.playerInteractWithBlock.subscribe(data => {
    const { player, itemStack, block } = data;
    if (block.typeId == "minecraft:fletching_table" && itemStack?.typeId == "minecraft:fishing_rod" && itemStack?.getLore()[0] !== "§aGrappling Hook Upgrade") {
        data.cancel = true;
        console.warn(itemStack?.getLore()[0]);
        system.run(() => main(player, itemStack));
    }

    const getItem = (player, itemId) => {
        let amount = 0;
        const inventory = player.getComponent("inventory").container;
        for (let slot = 0; slot < inventory.size; slot++) {
            const item = inventory.getItem(slot);
            if (item?.typeId == itemId) {
                amount += item.amount;
            }
        }
        return amount;
    };

    function main(player, item) {
        new ChestFormData('3')
            .title(`Fletching Table`)
            .button(0, '§aCraft', ['Click to Craft', '§8Costs 1 hook upgrade'], 'textures/items/fishing_rod_uncast')
            .button(2, 'Credits', ['Click to get the credits of all contributors'], 'textures/items/book_writable')
            .button(4, '§cCancel and Exit', ['Click to cancel the upgrade and exit'], 'minecraft:barrier')
            .show(player).then(response => {
                if (response.canceled) return;
                if (response.selection == 0) {
                    console.warn("works");
                    const amount = getItem(player, "vgh:grappling_hook_upgrade");
                    if (amount == 0) return player.sendMessage("§cUpgrade Failed, missing resources.");
                    if (amount != 0) {
                        player.runCommand("clear @s vgh:grappling_hook_upgrade 0 1");
                        item.setLore(["§aGrappling Hook Upgrade"]);
                        player.getComponent("inventory").container.setItem(player.selectedSlot, item);
                    }
                }
                if (response.selection == 2) {
                    console.warn("works");
                    player.sendMessage("§g§lCredits:");
                    player.sendMessage("§r");
                    player.sendMessage("§dMain Developer:");
                    player.sendMessage("§cxAssassin §b(Discord: @xassassin.)");
                    player.sendMessage("§r");
                    player.sendMessage("§dChest UI");
                    player.sendMessage("Herobrine64 §b(Discord: @herobrine64)");
                    player.sendMessage("§r");
                    player.sendMessage("§6Script Support and Bugfixing");
                    player.sendMessage("Fishy Dev §b(Discord: @fishy_dev)");
                    player.sendMessage("Hog §b(Discord: @hog554)§r");
                    player.sendMessage("Coddy §b(Discord: @coddy2009)");
                    player.sendMessage("Minato §b(Discord: @minato4743)");
                    player.sendMessage("Jaylay §b(Discord: @jaylymc)");
                    player.sendMessage("Trash Amythest/Azalea Dev §b(Discord: @powertrash)");
                }
                if (response.selection == 4) return;
            });
    }
});

world.afterEvents.projectileHitBlock.subscribe((event) => {
    const { projectile, source } = event;
    if (projectile.typeId !== "minecraft:fishing_hook" || !(source instanceof Player)) return;
    const inventory = source.getComponent("minecraft:inventory").container;
    const heldItem = inventory.getItem(source.selectedSlot);

    if (!heldItem || heldItem.typeId !== "minecraft:fishing_rod" || !heldItem.getLore().includes("§aGrappling Hook Upgrade")) return;

    // Get the location where the projectile hit the block
    const hitLocation = projectile.location;

    // Teleport the fishing_hook to the block it hit and make it stay there
    const id = system.runInterval(() => {
        if (!projectile.isValid()) {
            system.clearRun(id); // Cleanup if the projectile is no longer valid
        } else {
            // Continuously set the projectile's position to the hit location
            projectile.teleport(hitLocation);
        }
    }, 1); // Run this every tick to keep the projectile in place

    // Grappling mechanic
    let prevLoc;
    const grapplingId = system.runInterval(() => {
        if (projectile.isValid() && projectile.location) {
            prevLoc = projectile.location;
        } else {
            if (prevLoc && source.location) {
                const dir = Vector3.Normalize(Vector3.Subtract(prevLoc, source.location));
                const distance = Vector3.Distance(prevLoc, source.location);
                source.applyKnockback(dir.x, dir.z, distance * 0.4, dir.y + distance * 0.04);
            }
            system.clearRun(grapplingId);
        }
    });
});

